package Pumpe;

class KPumpe{
	private double h, q;
	private double[] ha, qa;  
	
	// Konstruktor, wie vorher
	public KPumpe (double H, double Q){ 
		h = H;
		q = Q;
	}
	
	// zustzlicher Konstruktor: Kennlinie
	public KPumpe (double[] H, double[] Q){
		ha = H; // Kopie der Referenz
		qa = Q; // Kopie der Referenz
		h = ha[0]; // Default Wert
		q = qa[0]; // Default Wert
	}
	// Getters
	public double GetH() {
		return h;
	}

	public double GetQ() {
		return q;
	}
	
	public static double Interpolate(double x, double[] in, double[] to) {
		double l = Double.NEGATIVE_INFINITY;
		double r = Double.POSITIVE_INFINITY;
		int left = -1;
		int right = -1; 
		for (int i = 0; i< in.length; ++i)
		{
			if (in[i] <= x && in[i] >= l)
			{
				l = in[i];
				left = i;
			}
			if (in[i] >= x && in[i] <= r)
			{
				r = in[i];
				right = i;
			}
		}
		if (left == -1){
			left = right;
			l = r;
		}
		if (right == -1){
			right = left;
			r = l;
		}
		double lambda= 0;
		if (r != l)
			lambda = (x-l)/(r-l);
		return lambda * to[right] + (1-lambda) * to[left];
	}

	// Setters
	public void SetH(double H) {
		h = H;
		q = Interpolate(H, ha, qa);
	}

	public void SetQ(double Q) {
		q = Q;
		h = Interpolate(Q, ha, qa);
	}
}

class KennlinienPumpe
{
	public static void main(String[] args)
	{
		double[] h = {55,50,40,30,20};
		double[] q = {0,0.01,0.02,0.03,0.035};
		KPumpe p = new KPumpe(h, q);
		for (double Q = 0; Q < 0.04; Q+= 0.005 )
		{
			p.SetQ(Q);
			System.out.println(p.GetQ() + " -> " + p.GetH());
		}
		for (double H =-5 ; H < 100; H += 1 )
		{
			p.SetH(H);
			System.out.println(p.GetH() + " -> " + p.GetQ());
		}
		
	}
}